﻿UseZipPacker()

DeclareModule pack
  EnableExplicit
  Declare Open(file.s,pluginid=#PB_PackerPlugin_Zip)
  Declare Close()
  Declare Examine(pat.s="")
  Declare.s GetFileName()
  Declare GetFile(file.s="")
  Declare GetJson(file.s="")
EndDeclareModule
Module pack  
  Structure pack
    name.s
    size.q
  EndStructure
  Global NewList files.pack()
  Global pack
  Global *buf
  
  Procedure AllocMem(size)
    Static *buf,maxsize
    
    If size=0
      If *buf
        FreeMemory(*buf)
        *buf=0       
      EndIf
      ProcedureReturn 0
    EndIf
    
    If maxsize=0 Or *buf=0
      maxsize=10*1024
      *buf=AllocateMemory(maxsize)
    EndIf
    
    If size>maxsize
      FreeMemory(*buf)
      maxsize=size+1024
      *buf=AllocateMemory(maxsize)
    EndIf
    
    ProcedureReturn *buf
  EndProcedure
  
  Procedure Open(file.s,pluginid=#PB_PackerPlugin_Zip)
    If pack
      Close()
    EndIf
    
    pack=OpenPack(#PB_Any,file,pluginid)
    
    If pack And ExaminePack(pack)
      While NextPackEntry(pack)
        AddElement(files())
        files()\name=PackEntryName(pack)
        files()\size=PackEntrySize(pack)
        ;Debug files()\name+" "+files()\size
      Wend
    EndIf
    
    Debug "Pack:"+pack
    
    ProcedureReturn pack    
  EndProcedure
  
  Procedure Close()
    If pack
      ClosePack(pack)
    EndIf
    ClearList(files())
    AllocMem(0)
    pack=0
  EndProcedure
  
  Procedure Examine(pat.s="")
    Protected ret=#False
    Static oldpat.s,ignorefirst
    
    If pat=""
      pat=oldpat 
      If ignorefirst
        ignorefirst=#False
        ret=Bool(ListIndex(files())>=0)
      EndIf
    Else
      oldpat=pat
      ResetList(files())
      ignorefirst=#True      
    EndIf        
    
    If ret=#False
      While NextElement(files())
        If Left(files()\name,Len(pat))=pat
          ret=#True
          Break
        EndIf
      Wend  
    EndIf
    
    ProcedureReturn ret    
  EndProcedure
  
  Procedure.s GetFileName()
    If ListIndex(files())>=0
      ProcedureReturn files()\name
    Else
      ProcedureReturn ""
    EndIf
  EndProcedure
  
  Procedure FindFile(file.s)
    Protected ret=#False
    ForEach files()
      If files()\name=file
        ret=#True
        Break
      EndIf
    Next
    ProcedureReturn ret
  EndProcedure 
  
  Procedure GetFile(file.s="")
    If file<>"" And FindFile(file)=#False
      ProcedureReturn 0
    EndIf
    
    If ListIndex(files())<0
      ProcedureReturn 0
    EndIf
    
    *buf=AllocMem(files()\size)
    If UncompressPackMemory(pack,*buf,files()\size,files()\name)>0
      ProcedureReturn *buf
    EndIf
    
    ProcedureReturn 0
  EndProcedure
    
  Procedure GetJson(file.s="")
    If GetFile(file)
      ProcedureReturn CatchJSON(#PB_Any,*buf,files()\size)
    EndIf
    ProcedureReturn 0
  EndProcedure
EndModule
; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 1
; Folding = --
; EnableXP