﻿Procedure IsLeft(*str1.character,*str2.character)
  While *str1\c=*str2\c
    *str1+SizeOf(character)
    *str2+SizeOf(character)
  Wend
  If *str2\c=0
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure


Procedure GadMiddle(gad,x,y,w=#PB_Ignore,minh=0)
  Protected h=GadgetHeight(gad,#PB_Gadget_RequiredSize)
  If w=#PB_Any
    w=GadgetWidth(gad,#PB_Gadget_RequiredSize)
  EndIf
  If minh=0
    minh=h
  EndIf
  ResizeGadget(gad, x,y+(minh-h)/2,w,h)
  ProcedureReturn minh
  
EndProcedure

Procedure GadNormal(gad,x,y,w=#PB_Ignore,minh=0)
  Protected h=GadgetHeight(gad,#PB_Gadget_RequiredSize)
  If w=#PB_Any
    w=GadgetWidth(gad,#PB_Gadget_RequiredSize)
  EndIf
  If minh>h
    h=minh
  EndIf
  ResizeGadget(gad, x,y,w,h)
  ProcedureReturn h
EndProcedure

Procedure GadUp(gad,x,y,w=#PB_Ignore,minh=0)
  Protected h=GadgetHeight(gad,#PB_Gadget_RequiredSize)
  If w=#PB_Any
    w=GadgetWidth(gad,#PB_Gadget_RequiredSize)
  EndIf
  If minh>h
    h=minh
  EndIf
  ResizeGadget(gad, x,y-h,w,h)
  ProcedureReturn h
EndProcedure

Procedure GadRight(gad,x,y,w=#PB_Ignore,minh=0)
  Protected h=GadgetHeight(gad,#PB_Gadget_RequiredSize)
  Protected ww=GadgetWidth(gad,#PB_Gadget_RequiredSize)
  If minh>h
    h=minh
  EndIf
  If w=#PB_Ignore
    w=GadgetWidth(gad)
  EndIf
  ResizeGadget(gad,x+w-ww,y,ww,h)
  ProcedureReturn h
EndProcedure
  
Procedure.s UpCase(str.s,i)
  ProcedureReturn Left(str,i-1) + UCase(Mid(str,i,1)) + Mid(str,i+1)
EndProcedure
Procedure.s _ucase(str.s)
  Protected a
  str=UpCase(str,1)
  Repeat
    a=FindString(str,"_",a)
    If a=0
      Break
    EndIf
    a+1
    str=UpCase(str,a)
    
  ForEver
  ProcedureReturn str
EndProcedure
Procedure LoadFile(file.s)
  Protected *mem,in,size
  in=ReadFile(#PB_Any,file)
  If in
    size=Lof(in)
    If size>0
      *mem=AllocateMemory(size)
      If *mem
        ReadData(in,*mem,size)
      EndIf
    EndIf
    CloseFile(in)
  EndIf
  ProcedureReturn *mem  
EndProcedure

Structure sGadItem
  text.s
  icon.i
  *dat
  tooltip.s
EndStructure

Procedure GadgetSortFill(gad,List items.sGadItem())
  Protected i
  SortStructuredList(items(),#PB_Sort_Ascending, OffsetOf(sGadItem\text),#PB_String)
  
  HideGadget(gad,#True)
  ClearGadgetItems(gad)
  i=0
  ForEach items()
    If items()\icon
      AddGadgetItem(gad,i, items()\text,ImageID(items()\icon))
    Else
      AddGadgetItem(gad,i, items()\text)      
    EndIf
    SetGadgetItemData(gad,i, items()\dat)
    
    i+1
  Next
  HideGadget(gad,#False)
EndProcedure
Procedure AddGadgetFill(gad,List items.sGadItem())
  Protected i
  HideGadget(gad,#True)  
  i=CountGadgetItems(gad)
  ForEach items()
    If items()\icon
      AddGadgetItem(gad,i, items()\text,ImageID(items()\icon))
    Else
      AddGadgetItem(gad,i, items()\text)      
    EndIf
    SetGadgetItemData(gad,i, items()\dat)
    i+1
  Next
  HideGadget(gad,#False)
EndProcedure

Macro LOWORD(Value)
  (Value & $FFFF)
EndMacro

Macro HIWORD(Value)
  ((Value >> 16) & $FFFF)
EndMacro 

Procedure allowedchars(str.s)
  Protected ret=#True
  Protected *char.character
  *char=@str
  While *char\c<>0
    Select *char\c
      Case 'a' To 'z', '0' To '9', '_'
      Default
        ret=#False
        Break
    EndSelect    
    *char+SizeOf(character)
  Wend
  ProcedureReturn ret
EndProcedure  

Global Dim RandomName.s(49)
RandomName(0)="﻿Diane"
RandomName(1)="Calandra"
RandomName(2)="Darlene"
RandomName(3)="Hattie"
RandomName(4)="Les"
RandomName(5)="Reagan"
RandomName(6)="Sonny"
RandomName(7)="Hobert"
RandomName(8)="Inell"
RandomName(9)="Lisandra"
RandomName(10)="Maryetta"
RandomName(11)="Gino"
RandomName(12)="Irish"
RandomName(13)="Lory"
RandomName(14)="Aja"
RandomName(15)="Wendi"
RandomName(16)="Lourie"
RandomName(17)="Fidel"
RandomName(18)="Emiko"
RandomName(19)="Brandee"
RandomName(20)="Winona"
RandomName(21)="Antoinette"
RandomName(22)="Twanda"
RandomName(23)="Caren"
RandomName(24)="Yi"
RandomName(25)="Marilyn"
RandomName(26)="Marquis"
RandomName(27)="Dyan"
RandomName(28)="Antoine"
RandomName(29)="Alisa"
RandomName(30)="Chandra"
RandomName(31)="Hyacinth"
RandomName(32)="Madge"
RandomName(33)="Daniele"
RandomName(34)="Solange"
RandomName(35)="Rhoda"
RandomName(36)="Drusilla"
RandomName(37)="Aiko"
RandomName(38)="Jorge"
RandomName(39)="Mack"
RandomName(40)="Teresa"
RandomName(41)="Conception"
RandomName(42)="Vashti"
RandomName(43)="Ellena"
RandomName(44)="Oleta"
RandomName(45)="Maegan"
RandomName(46)="Emmett"
RandomName(47)="Oda"
RandomName(48)="Olympia"
RandomName(49)="Casandra"
Procedure.s GetRandomName()
  Protected ret.s,i
  For i=0 To 2
    ret + RandomName( Random(ArraySize(RandomName())))
  Next
  ret+Hex(Random($ffff))
  ProcedureReturn ret
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 217
; FirstLine = 169
; Folding = ---
; EnableXP